#!/usr/bin/python
# -*- coding: utf-8 -*-
### BEGIN LICENSE
# Copyright (C) 2010 Skyler Lehmkuhl
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

def join(List, char=""):
	#Simple implementation of join
	#If it isn't obvious, it shouldn't be changed
	ret = ""
	for i in range(len(List)):
		if not i==len(List)-1:
			ret = ret + str(List[i]) + char
		else:
			ret = ret + str(List[i])
	return str(ret)
def check(script):
	errors = []
	line = 1
	paren = 0
	curly = 0
	brack = 0
	quote = False
	for i in range(len(script)):
		if script[i] == "\n":
			if script[i-1]==";":
				print "Good"
			else:
				errors.append("Line "+str(line)+": Semicolon missing")
			line+=1
			if paren>0:
				errors.append("Line "+str(line)+": Missing \")\"")
				break;
			if quote==True:
				errors.append("Line "+str(line)+": Missing \"")
				break;
		elif i==len(script)-1:
			if script[i]==";":
				print "Good"
			else:
				errors.append("Line "+str(line)+": Semicolon missing")
			if paren>0:
				errors.append("Line "+str(line)+": Extra \"(\" - missing a \")\"")
			if curly>0:
				errors.append("Line "+str(line)+": Extra \"{\" - missing a \"}\"")
			if brack>0:
				errors.append("Line "+str(line)+": Extra \"[\" - missing a \"]\"") 
		elif script[i] == "(":
			paren+=1;
		elif script[i] == ")":
			paren-=1;
			if paren<0:
				errors.append("Line "+str(line)+": Encountered \")\" without matching \"(\"")
				break;
		elif script[i] == "{":
			curly+=1;
		elif script[i] == "}":
			curly-=1;
			if curly<0:
				errors.append("Line "+str(line)+": Encountered \"}\" without matching \"{\"")
				break;
		elif script[i] == "[":
			curly+=1;
		elif script[i] == "]":
			curly-=1;
			if curly<0:
				errors.append("Line "+str(line)+": Encountered \"]\" without matching \"[\"")
				break;
		elif script[i] == "\"":
			quote = not quote
		elif script[i] == "\'":
			errors.append("Line "+str(line)+": Please use double quotes instead of single quotes.")
			break;

			
				
	if not errors==[]:
		x = "The following errors were encountered. Please correct them and try again.\n"+join(errors, "\n")
	else:
		x = True
	return x;
